=== debian/changelog ===
arm-compute-library (19.11-1) unstable; urgency=low

  * Initial release (Closes: #946273)

 -- Compute Library Team <developer-compute@arm.com>  Thu, 31 Oct 2019 13:18:35 +0000
