## arm-compute-library 20.08+dfsg

=== SConstruct ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright (c) 2016, 2017 ARM Limited.
+# Copyright (c) 2016, 2017 Arm Limited.
 #
 # SPDX-License-Identifier: MIT
 #
@@ -40,8 +40,11 @@
     BoolVariable("debug", "Debug", False),
     BoolVariable("asserts", "Enable asserts (this flag is forced to 1 for debug=1)", False),
     BoolVariable("logging", "Logging (this flag is forced to 1 for debug=1)", False),
-    EnumVariable("arch", "Target Architecture", "armv7a", allowed_values=("armv7a", "arm64-v8a", "arm64-v8.2-a", "arm64-v8.2-a-sve", "x86_32", "x86_64")),
-    EnumVariable("os", "Target OS", "linux", allowed_values=("linux", "android", "bare_metal")),
+    EnumVariable("arch", "Target Architecture", "armv7a",
+                  allowed_values=("armv7a", "arm64-v8a", "arm64-v8.2-a", "arm64-v8.2-a-sve", "x86_32", "x86_64",
+                                  "armv8a", "armv8.2-a", "armv8.2-a-sve", "armv8.6-a", "x86")),
+    EnumVariable("estate", "Execution State", "auto", allowed_values=("auto", "32", "64")),
+    EnumVariable("os", "Target OS", "linux", allowed_values=("linux", "android", "tizen", "bare_metal")),
     EnumVariable("build", "Build type", "cross_compile", allowed_values=("native", "cross_compile", "embed_only")),
     BoolVariable("examples", "Build example programs", True),
     BoolVariable("gemm_tuner", "Build gemm_tuner programs", True),
@@ -52,12 +55,15 @@
     BoolVariable("gles_compute", "Enable OpenGL ES Compute Shader support", False),
     BoolVariable("embed_kernels", "Embed OpenCL kernels and OpenGL ES compute shaders in library binary", True),
     BoolVariable("set_soname", "Set the library's soname and shlibversion (requires SCons 2.4 or above)", False),
+    BoolVariable("tracing", "Enable runtime tracing", False),
     BoolVariable("openmp", "Enable OpenMP backend", False),
     BoolVariable("cppthreads", "Enable C++11 threads backend", True),
     PathVariable("build_dir", "Specify sub-folder for the build", ".", PathVariable.PathAccept),
     PathVariable("install_dir", "Specify sub-folder for the install", "", PathVariable.PathAccept),
     BoolVariable("exceptions", "Enable/disable C++ exception support", True),
+    PathVariable("linker_script", "Use an external linker script", "", PathVariable.PathAccept),
     ("toolchain_prefix", "Override the toolchain prefix", ""),
+    ("compiler_prefix", "Override the compiler prefix", ""),
     ("extra_cxx_flags", "Extra CXX flags to be appended to the build command", ""),
     ("extra_link_flags", "Extra LD flags to be appended to the build command", ""),
     ("compiler_cache", "Command to prefix to the C and C++ compiler (e.g ccache)", "")
@@ -101,6 +107,10 @@
 
 Help(vars.GenerateHelpText(env))
 
+if env['linker_script'] and env['os'] != 'bare_metal':
+    print("Linker script is only supported for bare_metal builds")
+    Exit(1)
+
 if env['build'] == "embed_only":
     SConscript('./SConscript', variant_dir=build_path, duplicate=0)
     Return()
@@ -130,7 +140,7 @@
 env.Append(CXXFLAGS = ['-Wall','-DARCH_ARM',
          '-Wextra','-pedantic','-Wdisabled-optimization','-Wformat=2',
          '-Winit-self','-Wstrict-overflow=2','-Wswitch-default',
-         '-fpermissive','-std=gnu++11','-Woverloaded-virtual', '-Wformat-security',
+         '-std=gnu++11','-Woverloaded-virtual', '-Wformat-security',
          '-Wctor-dtor-privacy','-Wsign-promo','-Weffc++','-Wno-overlength-strings'])
 
 env.Append(CPPDEFINES = ['_GLIBCXX_USE_NANOSLEEP'])
@@ -162,48 +172,70 @@
     env.Append(CXXFLAGS = ['-fopenmp'])
     env.Append(LINKFLAGS = ['-fopenmp'])
 
+# Validate and define state
+if env['estate'] == 'auto':
+    if 'v7a' in env['arch']:
+        env['estate'] = '32'
+    else:
+        env['estate'] = '64'
+
+# Map legacy arch
+if 'arm64' in env['arch']:
+    env['estate'] = '64'
+
+if 'v7a' in env['estate'] and env['estate'] == '64':
+    print("ERROR: armv7a architecture has only 32-bit execution state")
+    Exit(1)
+
 # Add architecture specific flags
 prefix = ""
-if env['arch'] == 'armv7a':
+if 'v7a' in env['arch']:
     env.Append(CXXFLAGS = ['-march=armv7-a', '-mthumb', '-mfpu=neon'])
-
-    if env['os'] == 'linux':
-        prefix = "arm-linux-gnueabihf-"
+    if env['os'] == 'android' or env['os'] == 'tizen':
+        env.Append(CXXFLAGS = ['-mfloat-abi=softfp'])
+    else:
         env.Append(CXXFLAGS = ['-mfloat-abi=hard'])
-    elif env['os'] == 'bare_metal':
-        prefix = "arm-eabi-"
-        env.Append(CXXFLAGS = ['-mfloat-abi=hard'])
-    elif env['os'] == 'android':
-        prefix = "arm-linux-androideabi-"
-        env.Append(CXXFLAGS = ['-mfloat-abi=softfp'])
-elif env['arch'] == 'arm64-v8a':
-    env.Append(CXXFLAGS = ['-march=armv8-a'])
-    env.Append(CPPDEFINES = ['ARM_COMPUTE_AARCH64_V8A'])
-    if env['os'] == 'linux':
-        prefix = "aarch64-linux-gnu-"
-    elif env['os'] == 'bare_metal':
-        prefix = "aarch64-elf-"
-    elif env['os'] == 'android':
-        prefix = "aarch64-linux-android-"
-elif 'arm64-v8.2-a' in env['arch']:
-    if env['arch'] == 'arm64-v8.2-a-sve':
+elif 'v8' in env['arch']:
+    if 'sve' in env['arch']:
         env.Append(CXXFLAGS = ['-march=armv8.2-a+sve+fp16+dotprod'])
-    else:
+    elif 'v8.2-a' in env['arch']:
         env.Append(CXXFLAGS = ['-march=armv8.2-a+fp16']) # explicitly enable fp16 extension otherwise __ARM_FEATURE_FP16_VECTOR_ARITHMETIC is undefined
-    if env['os'] == 'linux':
-        prefix = "aarch64-linux-gnu-"
-    elif env['os'] == 'bare_metal':
-        prefix = "aarch64-elf-"
-    elif env['os'] == 'android':
-        prefix = "aarch64-linux-android-"
-    env.Append(CPPDEFINES = ['ARM_COMPUTE_AARCH64_V8_2'])
-elif env['arch'] == 'x86_32':
-    env.Append(CCFLAGS = ['-m32'])
-    env.Append(LINKFLAGS = ['-m32'])
-elif env['arch'] == 'x86_64':
-    env.Append(CXXFLAGS = ['-fPIC'])
-    env.Append(CCFLAGS = ['-m64'])
-    env.Append(LINKFLAGS = ['-m64'])
+    else:
+        env.Append(CXXFLAGS = ['-march=armv8-a'])
+
+    if 'v8.6-a' in env['arch']:
+        env.Append(CPPDEFINES = ['MMLA_INT8', 'MMLA_FP32', 'V8P6', 'V8P6_BF', 'ARM_COMPUTE_FORCE_BF16'])
+
+elif 'x86' in env['arch']:
+    if env['estate'] == '32':
+        env.Append(CCFLAGS = ['-m32'])
+        env.Append(LINKFLAGS = ['-m32'])
+    else:
+        env.Append(CXXFLAGS = ['-fPIC'])
+        env.Append(CCFLAGS = ['-m64'])
+        env.Append(LINKFLAGS = ['-m64'])
+
+# Define toolchain
+prefix = ""
+if 'x86' not in env['arch']:
+    if env['estate'] == '32':
+        if env['os'] == 'linux':
+            prefix = "arm-linux-gnueabihf-" if 'v7' in env['arch'] else "armv8l-linux-gnueabihf-"
+        elif env['os'] == 'bare_metal':
+            prefix = "arm-eabi-"
+        elif env['os'] == 'android':
+            prefix = "arm-linux-androideabi-"
+        elif env['os'] == 'tizen':
+            prefix = "armv7l-tizen-linux-gnueabi-"
+    elif env['estate'] == '64' and 'v8' in env['arch']:
+        if env['os'] == 'linux':
+            prefix = "aarch64-linux-gnu-"
+        elif env['os'] == 'bare_metal':
+            prefix = "aarch64-elf-"
+        elif env['os'] == 'android':
+            prefix = "aarch64-linux-android-"
+        elif env['os'] == 'tizen':
+            prefix = "aarch64-tizen-linux-gnu-"
 
 if env['build'] == 'native':
     prefix = ""
@@ -211,8 +243,12 @@
 if env["toolchain_prefix"] != "":
     prefix = env["toolchain_prefix"]
 
-env['CC'] = env['compiler_cache']+" "+prefix + c_compiler
-env['CXX'] = env['compiler_cache']+" "+prefix + cpp_compiler
+compiler_prefix = prefix
+if env["compiler_prefix"] != "":
+    compiler_prefix = env["compiler_prefix"]
+
+env['CC'] = env['compiler_cache']+ " " + compiler_prefix + c_compiler
+env['CXX'] = env['compiler_cache']+ " " + compiler_prefix + cpp_compiler
 env['LD'] = prefix + "ld"
 env['AS'] = prefix + "as"
 env['AR'] = prefix + "ar"
@@ -250,48 +286,9 @@
 
 if env['os'] == 'android':
     env.Append(CPPDEFINES = ['ANDROID'])
-    env.Append(LINKFLAGS = ['-pie', '-static-libstdc++'])
+    env.Append(LINKFLAGS = ['-pie', '-static-libstdc++', '-ldl'])
 elif env['os'] == 'bare_metal':
     env.Append(LINKFLAGS = ['-static'])
     env.Append(LINKFLAGS = ['-specs=rdimon.specs'])
     env.Append(CXXFLAGS = ['-fPIC'])
     env.Append(CPPDEFINES = ['NO_MULTI_THREADING'])
-    env.Append(CPPDEFINES = ['BARE_METAL'])
-
-if env['opencl']:
-    if env['os'] in ['bare_metal'] or env['standalone']:
-        print("Cannot link OpenCL statically, which is required for bare metal / standalone builds")
-        Exit(1)
-
-if env['gles_compute']:
-    if env['os'] in ['bare_metal'] or env['standalone']:
-        print("Cannot link OpenGLES statically, which is required for bare metal / standalone builds")
-        Exit(1)
-
-if env["os"] not in ["android", "bare_metal"] and (env['opencl'] or env['cppthreads']):
-    env.Append(LIBS = ['pthread'])
-
-if env['opencl'] or env['gles_compute']:
-    if env['embed_kernels']:
-        env.Append(CPPDEFINES = ['EMBEDDED_KERNELS'])
-
-if env['debug']:
-    env['asserts'] = True
-    env['logging'] = True
-    env.Append(CXXFLAGS = ['-O0','-g','-gdwarf-2'])
-    env.Append(CPPDEFINES = ['ARM_COMPUTE_DEBUG_ENABLED'])
-else:
-    env.Append(CXXFLAGS = ['-O3'])
-
-if env['asserts']:
-    env.Append(CPPDEFINES = ['ARM_COMPUTE_ASSERTS_ENABLED'])
-    env.Append(CXXFLAGS = ['-fstack-protector-strong'])
-
-if env['logging']:
-    env.Append(CPPDEFINES = ['ARM_COMPUTE_LOGGING_ENABLED'])
-
-env.Append(CPPPATH = ['#/include', "#"])
-env.Append(CXXFLAGS = env['extra_cxx_flags'])
-env.Append(LINKFLAGS = env['extra_link_flags'])
-
-Default( install_include("arm_compute"))
