=== debian/changelog ===
arm-compute-library (20.08+dfsg-7) unstable; urgency=medium

  * Actually include d/patches/missing-includes.patch, all changes to d/patches
    got removed by dgit.

 -- Emanuele Rocca <ema@debian.org>  Fri, 03 Mar 2023 14:31:21 +0100

arm-compute-library (20.08+dfsg-6) unstable; urgency=medium

  * Add d/patches/missing-includes.patch to fix FTBFS (Closes: #1032041)
  * Add myself to Uploaders with Wookey's permission.

 -- Emanuele Rocca <ema@debian.org>  Fri, 03 Mar 2023 14:12:26 +0100

arm-compute-library (20.08+dfsg-5) unstable; urgency=medium

  * Re-release as source-only upload

 -- Compute Library Team <developer-compute@arm.com>  Fri, 06 Nov 2020 00:30:42 +0000

arm-compute-library (20.08+dfsg-4) unstable; urgency=medium

  * Install library files in libarm-compute20

 -- Compute Library Team <developer-compute@arm.com>  Wed, 04 Nov 2020 04:01:19 +0000

arm-compute-library (20.08+dfsg-3) unstable; urgency=medium

  * Correct -dev package dependencies for SONAME 20

 -- Wookey <wookey@debian.org>  Mon, 02 Nov 2020 23:18:32 +0000

arm-compute-library (20.08+dfsg-2) unstable; urgency=medium

  * Dgit retry

 -- Compute Library Team <developer-compute@arm.com>  Sun, 01 Nov 2020 22:51:48 +0000

arm-compute-library (20.08+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Compute Library Team <developer-compute@arm.com>  Fri, 30 Oct 2020 02:50:53 +0000

arm-compute-library (19.11-3) unstable; urgency=medium

  * Fix arch check logic to allow arch-indep build on any architecture

 -- Compute Library Team <developer-compute@arm.com>  Thu, 24 Sep 2020 17:49:17 +0100

arm-compute-library (19.11-2) unstable; urgency=medium

  * Bump Standards, source-only upload
  * Assorted lintian fixes

 -- Compute Library Team <developer-compute@arm.com>  Thu, 17 Sep 2020 17:49:17 +0100
