=== debian/control ===
--- 
+++ 
@@ -2,16 +2,18 @@
 Section: libs
 Priority: optional
 Maintainer: Compute Library Team <developer-compute@arm.com>
-Uploaders: Georgios Pinitas <georgios.pinitas@arm.com>,
-Standards-Version: 4.3.0
+Uploaders: Georgios Pinitas <georgios.pinitas@arm.com>, Emanuele Rocca <ema@debian.org>
+Standards-Version: 4.5.0
 Homepage: https://github.com/ARM-software/ComputeLibrary
+Vcs-git: https://salsa.debian.org/wookey/arm-compute-library
+Rules-Requires-Root: no
 Build-Depends: debhelper-compat (= 12),
                dh-exec (>=0.3),
                scons (>= 2.4),
                doxygen,
                graphviz
 
-Package: libarm-compute17
+Package: libarm-compute20
 Architecture: armhf arm64
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -29,7 +31,7 @@
 Section: libdevel
 Architecture: armhf arm64
 Multi-Arch: same
-Depends: libarm-compute17 (= ${binary:Version}), ${misc:Depends}
+Depends: libarm-compute20 (= ${binary:Version}), ${misc:Depends}
 Suggests: libarm-compute-doc (= ${source:Version})
 Description: Arm Compute Library - development files
  Arm Compute Library is a software library for computer vision and
