=== debian/watch ===
# Compulsory line, this is a version 4 file
version=4

opts=filenamemangle=s/.+\/v?(\d\S+)\.zip/ComputeLibrary-$1\.zip/ \
  https://github.com/Arm-software/ComputeLibrary/tags .*/v?(\d\S+)\.zip
